"use strict";
cc._RF.push(module, '15d2c/u7bBLyI6Cb4zmUUDa', 'JoyStick');
// Script/JoyStick.ts

"use strict";
// Learn TypeScript:
//  - https://docs.cocos.com/creator/manual/en/scripting/typescript.html
// Learn Attribute:
//  - https://docs.cocos.com/creator/manual/en/scripting/reference/attributes.html
// Learn life-cycle callbacks:
//  - https://docs.cocos.com/creator/manual/en/scripting/life-cycle-callbacks.html
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
Object.defineProperty(exports, "__esModule", { value: true });
var _a = cc._decorator, ccclass = _a.ccclass, property = _a.property;
var JoyStick = /** @class */ (function (_super) {
    __extends(JoyStick, _super);
    function JoyStick() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.panel = null; //大圆
        _this.btn = null; //小圆
        _this.panelWidth = 130; //去掉透明区域的大圆宽度
        _this.dir = new cc.Vec3(0, 0, 0); //移动方向
        _this.angle = 0; //弧度(角度)
        _this.moving = false; //是否正在移动
        return _this;
    }
    JoyStick.prototype.onLoad = function () {
        this.panelInitPos = new cc.Vec2(this.panel.x, this.panel.y);
    };
    JoyStick.prototype.start = function () {
        this.node.on(cc.Node.EventType.TOUCH_START, this.onTouchStart, this);
        this.node.on(cc.Node.EventType.TOUCH_MOVE, this.onTouchMove, this);
        this.node.on(cc.Node.EventType.TOUCH_END, this.onTouchEnd, this);
        this.node.on(cc.Node.EventType.TOUCH_CANCEL, this.onTouchCancel, this);
    };
    JoyStick.prototype.stop = function () {
        this.node.off(cc.Node.EventType.TOUCH_START, this.onTouchStart, this);
        this.node.off(cc.Node.EventType.TOUCH_MOVE, this.onTouchMove, this);
        this.node.off(cc.Node.EventType.TOUCH_END, this.onTouchEnd, this);
        this.node.off(cc.Node.EventType.TOUCH_CANCEL, this.onTouchCancel, this);
        this.moving = false;
        this.enabled = false;
    };
    JoyStick.prototype.onTouchStart = function (e) {
        console.log("start");
        //触摸点世界坐标转成局部坐标
        var pos = this.node.convertToNodeSpaceAR(e.getLocation());
        this.panel.setPosition(pos);
        this.btn.setPosition(0, 0);
        this.touchID = e.getID();
        this.moving = false;
        this.enabled = true;
    };
    JoyStick.prototype.onTouchMove = function (e) {
        console.log("move");
        if (this.touchID != e.getID()) {
            return;
        }
        //小圆移动
        var posDelta = e.getDelta();
        this.btn.x += posDelta.x;
        this.btn.y += posDelta.y;
        //正在移动
        this.moving = true;
    };
    JoyStick.prototype.update = function () {
        console.log("update");
        if (this.moving) {
            //将小圆限制大圆范围内
            var ratio = this.btn.position.mag() / this.panelWidth;
            if (ratio > 1) {
                this.btn.setPosition(this.btn.position.div(ratio));
            }
            //获取向量归一化
            this.dir = this.btn.position.normalizeSelf();
            //获取弧度
            this.angle = Math.atan2(this.btn.y, this.btn.x);
        }
    };
    JoyStick.prototype.onTouchEnd = function (e) {
        console.log("end");
        if (this.touchID != e.getID()) {
            return;
        }
        this.panel.setPosition(this.panelInitPos);
        this.btn.setPosition(0, 0);
        this.moving = false;
        this.enabled = false;
    };
    JoyStick.prototype.onTouchCancel = function (e) {
        console.log("cancel");
        if (this.touchID != e.getID()) {
            return;
        }
        this.panel.setPosition(this.panelInitPos);
        this.btn.setPosition(0, 0);
        this.moving = false;
        this.enabled = false;
    };
    JoyStick.prototype.onDestroy = function () {
        this.stop();
    };
    __decorate([
        property(cc.Node)
    ], JoyStick.prototype, "panel", void 0);
    __decorate([
        property(cc.Node)
    ], JoyStick.prototype, "btn", void 0);
    __decorate([
        property(cc.Integer)
    ], JoyStick.prototype, "panelWidth", void 0);
    JoyStick = __decorate([
        ccclass
    ], JoyStick);
    return JoyStick;
}(cc.Component));
exports.default = JoyStick;

cc._RF.pop();